//
//  GMThirdPartyDefine.h
//  Gengmei
//
//  Created by licong on 2017/8/2.
//  Copyright © 2017年 更美互动信息科技有限公司. All rights reserved.
//

#ifndef GMThirdPartyDefine_h
#define GMThirdPartyDefine_h

typedef NS_ENUM(NSInteger, GMShareResponseState) {
    GMShareResponseStateBegin           = -1,
    GMShareResponseStateSuccess         =  0,
    GMShareResponseStateFail            =  1,
    GMShareResponseStateCancel          =  2,
    GMShareResponseStateBack            =  3,
};

typedef NS_ENUM(NSInteger, GMSharePlatform) {
    GMSharePlatformUnknown          = -1,
    GMSharePlatformSinaWeibo        =  0,           /**< 新浪微博 */
    GMSharePlatformQQSpace          =  1,           /**< QQ空间 */
    GMSharePlatformQQFriend         =  2,           /**< QQ好友 */
    GMSharePlatformWechatSession    =  3,           /**< 微信好友 */
    GMSharePlatformWechatTimeline   =  4,           /**< 微信朋友圈 */

    GMSharePlatformFav      = 5,                    /**< 收藏 */
    GMSharePlatformDelete   = 6,                    /**< 删除 */
    GMSharePlatformCopyLink = 7,                    /**< 复制链接 */
    GMSharePlatformRefresh  = 8,                    /**< 刷新 */
    GMSharePlatformReport   = 9,                    /**< 举报 */
    GMSharePlatformCancelFollow = 10,               /**< 圈子取消关注 */
    GMSharePlatformWechatSessionSnapShot = 11,      /**< 微信好友快照 */
    GMSharePlatformWechatTimelineSnapShot = 12,     /**< 微信朋友圈快照 */
    GMSharePlatformWechatMiniProgram = 13,          /**< 微信小程序分享 */
    GMSharePlatformPrivateMsg = 14,          /**< 更美私信 */
    GMSharePlatformInviteAnswer = 15,               /** 邀请回复(回复详情和问题详情界面) */
    GMSharePlatformWechat              = 100,       /**< 微信平台*/
    GMSharePlatformQQ                  = 101,       /**< QQ平台*/
    GMSharePlatformDouyin                  = 102,       /**< 抖音*/
};


/**
 *  内容类型
 */
typedef NS_ENUM(NSUInteger, GMShareContentType){
    
    /**
     *  自动适配类型，视传入的参数来决定
     */
    GMShareContentTypeAuto         = 0,
    
    /**
     *  文本
     */
    GMShareContentTypeText         = 1,
    
    /**
     *  图片
     */
    GMShareContentTypeImage        = 2,
    
    /**
     *  网页
     */
    GMShareContentTypeWebPage      = 3,
    
    /**
     *  应用
     */
    GMShareContentTypeApp          = 4,
    
    /**
     *  音频
     */
    GMShareContentTypeAudio        = 5,
    
    /**
     *  视频
     */
    GMShareContentTypeVideo        = 6,
    
    /**
     *  文件类型(暂时仅微信可用)
     */
    GMShareContentTypeFile         = 7,
    
    //图片类型 仅FacebookMessage 分享图片并需要明确结果时 注此类型分享后不会显示应用名称与icon
    //v3.6.2 增加
    GMShareContentTypeFBMessageImages = 8,
    
    //图片类型 仅FacebookMessage 分享视频并需要明确结果时 注此类型分享后不会显示应用名称与icon
    //所分享的视频地址必须为相册地址
    //v3.6.2 增加
    GMShareContentTypeFBMessageVideo = 9,
    
    //3.6.3 小程序分享(暂时仅微信可用)
    GMShareContentTypeMiniProgram  = 10
};


#define kQQLogin         @"kQQLogin"
#define kSinaLogin       @"kSinaLogin"
#define kWechatLogin     @"kWechatLogin"
#define kWechatPaySuccess       @"kWechatPaySuccess"
#define kWechatPayFail          @"kWechatPayFail"

//QQ好友和朋友圈会掉的url完全一样，所以没必要区分 QQ41A1DB6D://response_from_qq?source=qq&source_scheme=mqqapi&error=0&version=1&sdkv=3.1
#define kQQShare               @"kQQShare"
#define kSinaShare             @"kSinaShare"
#define kWechatShare           @"kWechatShare"
#define kDouyinShare           @"kDouyinShare"

#define kThirdPartyLoginBack     @"kThirdPartyLoginBack"
#define kThirdPartyShareBack     @"kThirdPartyShareBack"
#define WEICHAT_BASE_URL        @"https://api.weixin.qq.com/sns"


#ifdef APPSTORE
#define WEIXIN_APPID      @"wx4326da3ad2429149"
#define WEIXIN_SECRET     @"971147c78f55c3a657394a7a31f4266a"
#else
#define WEIXIN_APPID    @"wx403cd28c142c7d87"
#define WEIXIN_SECRET   @"035af39ad74bbc01b7517a291c836827"
#endif

#define QQ_APPID @"1101126509"
//16进制的QQ appid
#define QQ_HEX_APPID @"41A1DB6D"
#define QQ_APPKEY @"yD4Eu3WZX6egmrMU"

// 新浪
#define SINAWEIBO_APPID @"2387882244"
#define SINAWEIBO_APPKEY @"8480ee24118f0dec4f71e0ca1ba8638e"
#define SINAWEIBO_REDIRECTURI                   @"http://www.wanmeizhensuo.com/api/user/weibo/auth/"

// 抖音 APPID
#define DOUYIN_APPID @"awedc2tmuly0pozy"
#define DOUYIN_APPKEY @"cd39b2610b33244eef66eab3327e4d72"
#endif
